/* 
   $Id: nnmsample.c,v 1.6 2001/09/25 05:35:09 sho Exp $

   Copyright (C) 2001 AXE,Inc. <sg@axe-inc.co.jp>

   This file is part of Nunome.

   Nunome is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Nunome is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Nunome; see the file COPYING.   If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA. */

#include <stdio.h>
#include <unistd.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Xlocale.h>

#include <X11/Composite.h>

#include <X11/Xaw/Cardinals.h>
#include <X11/Xaw/Simple.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Box.h>

#include "Nnm.h"
#include "NnmProto.h"
#include "nnmCanvas.h"
#include "nnmUtil.h"

/* ʸ󼨤뤿Window Size */
#define NnmDISP_KANJI_SIZE	20

/* ǧоݤȤʤʸϰ */
CodeSet	JisCode[]={
  { 0x2122, 0x2123 },	/* ten, maru */
  { 0x2126, 0x212a },	/* kuromaru etc */
  { 0x2133, 0x213a },	/* onaji etc */
  { 0x213c, 0x213c },	/* tyouon */
  { 0x2330, 0x2339 },	/* 0-9 */
  { 0x2341, 0x235a },	/* A-Z */
  { 0x2361, 0x237a },	/* a-z */
  { 0x2421, 0x2473 },	/* Ҥ餬 */
  { 0x2521, 0x2576 },	/*  */
  { 0x3021, 0x4f53 },	/* JIS1 */
  { 0x5021, 0x7424 }	/* JIS2 */
};
static int	kind = 0;

Widget		dispWidget, resultWidget;	/* ʸ,ǧɽWidget*/
XFontStruct	*kfs = NULL;			/* ɽFont */
unsigned long	disp_code = 0x2122;		/* ʸ */
unsigned long	result_code = 0;		/* ǧʸ */
FILE		*idxfp;
char		idxfn[2048];

int		num_input = 0;

/*************** ʣեбͽ *************************/
char		*dicfn=NULL;			/* ե̾ */
char		*sampfn=NULL;			/* ʸץ¸ե */


/*
 *󼨤ʸɤꤹ(JIS Code)
 */
static	void	NewdispCode()
{
  int		hi, lo, tmp;

  num_input++;
  printf("%6d Character is written. (Code = %4lX)\r",
	 num_input, disp_code );
  fflush( stdout );

  hi = disp_code >> 8;
  lo = disp_code & 0xff;
  lo++;
  if ( lo>0x7e ){	/* JISβbyte0x21-0x7e */
    lo = 0x21;
    hi++;
  }
  tmp = hi<<8 | lo;
  if ( tmp <= JisCode[kind].ed ){
    disp_code = tmp;
    return ;
  }
  kind++;
  if ( kind >= XtNumber(JisCode) ){	/* ֤ */
    kind = 0;
  }
  disp_code = JisCode[kind].st;
}

/* dispWidgetκ襤٥ȥХå */
static	void	dispExposure( w, clo, ev, ctd )
     Widget	w;
     XtPointer	clo;
     XEvent	*ev;
     Boolean	*ctd;
{
  NnmDisplayKanjiChar( dispWidget, disp_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}


/* resultWidgetκ襤٥ȥХå */
static	void	dispResultExposure( w, clo, ev, ctd )
     Widget	w;
     XtPointer	clo;
     XEvent	*ev;
     Boolean	*ctd;
{
  NnmDisplayKanjiChar( resultWidget, result_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}

  
/*
 * ʸȤΥꥢ
 * Clear Button Callback
 */
static	void	NnmClear( w, clo, cli )
     Widget	w;
     XtPointer	clo, cli;
{
    NnmCanvasClear((NnmCanvasRec *)clo);
}

/*
 * ʸ˥å
 */
static	void	NnmSkip( w, clo, cli )
     Widget	w;
     XtPointer	clo, cli;
{
  NnmCanvasClear((NnmCanvasRec *)clo);
  NewdispCode();			/* ʸι */
  NnmDisplayKanjiChar( dispWidget, disp_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}



/*
 */
static	void	NnmBack( w, clo, cli )
     Widget	w;
     XtPointer	clo, cli;
{
  int fd;
  NnmRawCharInfoRec charInfo;
  NnmCanvasRec	*canvasInfo = (NnmCanvasRec *)clo;
  long prev = 0;
  long last = 0;

  NnmCanvasClear((NnmCanvasRec *)clo);
  if (num_input <= 0) return;
  num_input--;
  if ((fd = NnmFOpen(sampfn,"r+")) < 0) {
    fprintf(stderr,"Can't open sample file:%s\n",sampfn);
    exit(2);
  }
  while (NnmSampleReadFile(&charInfo,&disp_code,fd) >= 0) {
    prev = last;
    last = NnmFTell(fd);
  }
  ftruncate(fd,prev);
  NnmFClose(fd);
  canvasInfo->CharInfo = charInfo;
  canvasInfo->clean = False;
  NnmCanvasDraw(canvasInfo);
  NnmDisplayKanjiChar( dispWidget, disp_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}


/*
 * ϥȥϿ
 */
static	void	NnmInput( w, clo, cli )
     Widget	w;
     XtPointer	clo, cli;
{
  NnmCanvasRec	*canvasInfo = (NnmCanvasRec *)clo;

  NnmSampleAppendFile( &(canvasInfo->CharInfo), disp_code, sampfn );
  /* ȥꥢ */
  NnmCanvasClear((NnmCanvasRec *)clo);
  NewdispCode();			/* ʸι */
  NnmDisplayKanjiChar( dispWidget, disp_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}


/*
 * ϥȥϿ&ǧ
 */
static	void	NnmInputRecognize( w, clo, cli )
     Widget	w;
     XtPointer	clo, cli;
{
  NnmCanvasRec	*canvasInfo = (NnmCanvasRec *)clo;
  NnmCandidateRec	cands[MAX_CANDIDATE_CATEGORY];
  NnmFeatureRec fv;

  if ( canvasInfo->CharInfo.num<=0 ) return; 	/* 0ʲ */

  /* ץϿ */
  NnmSampleAppendFile( &(canvasInfo->CharInfo), disp_code, sampfn );

  /* ǧ¹ */
  result_code = NnmRecognizeCharacterInfo( &(canvasInfo->CharInfo),
				       cands, MAX_CANDIDATE_CATEGORY,
				       &fv,NULL, disp_code);
  NnmDisplayKanjiChar( resultWidget, result_code, 
		       kfs, 1, NnmDISP_KANJI_SIZE-5 );
  
  /* ȥꥢ */
  NnmCanvasClear((NnmCanvasRec *)clo);
  NewdispCode();			/* ʸι */
  NnmDisplayKanjiChar( dispWidget, disp_code, kfs, 1, NnmDISP_KANJI_SIZE-5 );
}


/* Quit Button Callback */
static	void	Quit()
{
  idxfp = fopen( idxfn, "w" );
  fprintf( idxfp, "%lx", disp_code );
  fclose( idxfp );
  fprintf( stderr, "Quit Button\n");
  exit(0);
}


static	void	Usage(char *cmd)
{
  fprintf( stderr, "Usage:%s [dic file] [sample file]\n",cmd);
  exit(1);
  
}


int	main( argc, argv )
     int	argc;
     char	**argv;
{
  int		i;
  ulong		st_code;
  XtAppContext	app_con;
  Widget	toplevel, InputBtn, ClearBtn, SkipBtn;
  Widget	topBox,dispBox,inputBox,buttonBox;
  Widget	QuitBtn, RecogBtn, BackBtn;
  NnmCanvasRec	canvasInfo1;
  Arg		args[10];
  Cardinal	n;
    
  /* International */
  setlocale( LC_ALL, "" );
  XtSetLanguageProc( NULL, NULL, NULL );
  toplevel = XtAppInitialize(&app_con, "Nnmsample", NULL, 0,
			     &argc, argv, NULL, NULL, (Cardinal) 0);

  /* Private argument ( not for X11 option ) */
  if ( argc<=2 ){
    Usage(argv[0]);
  }
  dicfn = argv[1];
  NnmSetDictionaryFile(dicfn,0);
  sampfn = argv[2];
  sprintf( idxfn, "%s.idx", sampfn );
  if ( (idxfp=fopen( idxfn, "r" ))==NULL ){
    fprintf( stderr, "Index file is not found. Initialize\n");
  }else{
    char	tmp[2048];

    fgets( tmp, 2047, idxfp );
    sscanf( tmp, "%x", (int *)&st_code );
    for( i=0; i<XtNumber(JisCode); i++ ){
      if ( (JisCode[i].st<=st_code)&&(st_code<=JisCode[i].ed) ){
	disp_code = st_code;
	kind      = i;
	break;
      }
    }
    fclose( idxfp );
  }
  if ( argc>=4){
    sscanf( argv[3], "%x", (int *)&st_code );
    for( i=0; i<XtNumber(JisCode); i++ ){
      if ( (JisCode[i].st<=st_code)&&(st_code<=JisCode[i].ed) ){
	disp_code = st_code;
	kind      = i;
	break;
      }
    }
  }
  n = 0;
  XtSetArg( args[n], XtNborderWidth , 0 ); n++;
  topBox = XtCreateManagedWidget( "topBox", boxWidgetClass, toplevel,
			       args, n );
  /* ʸɽWidget */
  n = 0;
  XtSetArg( args[n], XtNborderWidth , 0 ); n++;
  XtSetArg( args[n], XtNorientation , XtorientHorizontal ); n++;
  dispBox = XtCreateManagedWidget( "dispBox", boxWidgetClass, topBox,
			       args, n );
  n = 0;
  XtSetArg( args[n], XtNheight,   NnmDISP_KANJI_SIZE ); n++;
  XtSetArg( args[n], XtNwidth ,   NnmDISP_KANJI_SIZE ); n++;
  dispWidget = XtCreateManagedWidget( "disp", simpleWidgetClass, dispBox,
				      args, n );
  XtAddEventHandler( dispWidget, ExposureMask, (Boolean)0, 
		     (XtEventHandler)dispExposure, (XtPointer)NULL );

  /* ǧʸɽWidget */
  n = 0;
  XtSetArg( args[n], XtNheight,   NnmDISP_KANJI_SIZE ); n++;
  XtSetArg( args[n], XtNwidth ,   NnmDISP_KANJI_SIZE ); n++;
  resultWidget = XtCreateManagedWidget( "result", simpleWidgetClass, dispBox,
					args, n );
  XtAddEventHandler( resultWidget, ExposureMask, (Boolean)0, 
		     (XtEventHandler)dispResultExposure, (XtPointer)NULL );
  
  /* ʸWidget */
  n = 0;
  XtSetArg( args[n], XtNborderWidth , 0 ); n++;
  XtSetArg( args[n], XtNorientation , XtorientHorizontal ); n++;
  inputBox = XtCreateManagedWidget( "inputBox", boxWidgetClass, topBox,
			       args, n );
  n = 0;
  XtSetArg( args[n], XtNwidth , NnmCANVAS_DISPLAY_SIZE ); n++;
  XtSetArg( args[n], XtNheight, NnmCANVAS_DISPLAY_SIZE ); n++;
  NnmCreateCanvas( &canvasInfo1, 0, inputBox, args, n );

  /* Button Widgets */
  n = 0;
  buttonBox = XtCreateManagedWidget( "buttonBox", boxWidgetClass, inputBox,
			       args, n );
  /* ץʸ¸ܥ */
  n = 0;
  XtSetArg( args[n], XtNlabel, "Sampling" );     	n++;
  InputBtn = XtCreateManagedWidget( "inputbtn", commandWidgetClass, buttonBox,
				    args, n );
  /* ץʸ¸+ǧ¹ԥܥ */
  n = 0;
  XtSetArg( args[n], XtNlabel, "Input & Recognize" );	n++;
  RecogBtn = XtCreateManagedWidget( "skipbtn", commandWidgetClass, buttonBox,
				    args, n );
  /* ʸ˥åפܥ */
  n = 0;
  XtSetArg( args[n], XtNlabel, "Skip" );    	n++;
  SkipBtn = XtCreateManagedWidget( "skipbtn", commandWidgetClass, buttonBox,
				    args, n );
  n = 0;
  XtSetArg( args[n], XtNlabel, "Back" );    	n++;
  BackBtn = XtCreateManagedWidget( "backbtn", commandWidgetClass, buttonBox,
				    args, n );
  /* ʸΥȥξõܥ(ľ) */
  n = 0;
  XtSetArg( args[n], XtNlabel, "Clear" );    	n++;
  ClearBtn = XtCreateManagedWidget( "clearbtn", commandWidgetClass, buttonBox,
				    args, n );
  /* ץꥱλܥ */
  n = 0;
  XtSetArg( args[n], XtNlabel, "Quit" );     n++;
  QuitBtn = XtCreateManagedWidget( "quitbtn", commandWidgetClass, buttonBox,
				    args, n );
  /* Button WidgetsCallbackؿϿ */
  XtAddCallback( InputBtn, XtNcallback, NnmInput, &canvasInfo1 );
  XtAddCallback( RecogBtn, XtNcallback, NnmInputRecognize, &canvasInfo1 );
  XtAddCallback( SkipBtn, XtNcallback, NnmSkip, &canvasInfo1 );
  XtAddCallback( BackBtn, XtNcallback, NnmBack, &canvasInfo1 );
  XtAddCallback( ClearBtn, XtNcallback, NnmClear, &canvasInfo1 );
  XtAddCallback( QuitBtn, XtNcallback, Quit, &canvasInfo1 );

  XtRealizeWidget(toplevel);
  XtAppMainLoop(app_con);
  return 0;
}
